'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.SHORTNAME_TO_CODEPOINT = exports.SHORTNAME_TO_UNICODE = exports.UNICODE_TO_SHORTNAME = undefined;

var _keys = require('babel-runtime/core-js/object/keys');

var _keys2 = _interopRequireDefault(_keys);

exports.convertToUnicode = convertToUnicode;

var _emoji = require('./emoji.json');

var _emoji2 = _interopRequireDefault(_emoji);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function convertToUnicode(codePoint) {
  if (codePoint.indexOf('-') >= 0) {
    return codePoint.split('-').map(convertToUnicode).join('');
  }

  var hex = parseInt(codePoint, 16);

  if (hex >= 0x10000 && hex <= 0x10FFFF) {
    return String.fromCharCode(Math.floor((hex - 0x10000) / 0x400) + 0xD800) + String.fromCharCode((hex - 0x10000) % 0x400 + 0xDC00);
  }

  return String.fromCharCode(hex);
}

var data = typeof _emoji2.default === 'string' ? JSON.parse(_emoji2.default) : _emoji2.default;
// const unicodeRegex = [];

var UNICODE_TO_SHORTNAME = exports.UNICODE_TO_SHORTNAME = {};
var SHORTNAME_TO_UNICODE = exports.SHORTNAME_TO_UNICODE = {};
var SHORTNAME_TO_CODEPOINT = exports.SHORTNAME_TO_CODEPOINT = {};

// Extract the shortname, codepoint and unicode
(0, _keys2.default)(data).forEach(function (name) {
  var codePoint = data[name];
  var shortName = ':' + name + ':';
  var unicode = convertToUnicode(codePoint);

  UNICODE_TO_SHORTNAME[unicode] = shortName;
  SHORTNAME_TO_UNICODE[shortName] = unicode;
  SHORTNAME_TO_CODEPOINT[shortName] = codePoint;

  // unicodeRegex.push(unicode);
});

// Sort the list so that the largest unicode characters are first
// export const EMOJI_PATTERN = `(?:${unicodeRegex.sort((a, b) => b.length - a.length).join('|')})`;
exports.default = data;